# Contributing

All pull requests are welcome! By participating in this project, you
agree to abide by our **[code of conduct]**.

[code of conduct]: https://github.com/remarkablemark/html-react-parser/blob/master/CODE_OF_CONDUCT.md

[Fork], then clone the repository:

[fork]: https://github.com/remarkablemark/html-react-parser/fork

```sh
# replace `<user>` with your username
$ git clone git@github.com:<user>/html-react-parser.git
$ cd html-react-parser
```

Install package dependencies:

```sh
$ npm install
```

Make your change. Add tests and/or documentation. Ensure all tests and lint pass:

```sh
$ npm test
$ npm run lint
```

Push to your fork and [submit a pull request][pr].

[pr]: https://github.com/remarkablemark/html-react-parser/compare/

At this point you're waiting on us. We like to comment on pull requests
within three business days (and, typically, one business day). We may suggest
changes, improvements, or alternatives.

Things that will improve the chance that your pull request will be accepted:

- [ ] Write tests that pass [CI].
- [ ] Write good documentation.
- [ ] Write a [good commit message][commit].

[ci]: https://travis-ci.org/remarkablemark/html-react-parser
[commit]: https://www.conventionalcommits.org/

## Test

Run tests:

```sh
$ npm test
```

Run tests with coverage:

```sh
$ npm run test:coverage
```

View coverage report in your browser:

```sh
$ npm run test:coverage:report
$ open coverage/index.html
```

## Lint

Lint codebase:

```sh
$ npm run lint
```

Fix lint errors:

```sh
$ npm run lint:fix
```

Test TypeScript declaration file for style and correctness:

```sh
$ npm run lint:dts
```

## Release

Only collaborators with credentials can release and publish:

```sh
$ npm run release
$ npm publish && git push --follow-tags
```
